;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Alternating Layer 1 & Layer 2 Interaction;
;           By MSAhm3d59113               ;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;Now works with vertical levels.                                                                                ;
;The level mode should be either 01 or 0F for horizontal levels, and 07 for vertical levels.                    ;
;If you are only having layer 2 interaction, use a mode which has that enabled. (02,08 or 1F)			;
;Choosing a level mode that enables layer 2 interaction causes temporary interaction with both layers.          ;
;Since it uses the frame counter, it is recommended to have a layer 1 and layer 2 block where the player starts.;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
print "INIT ",pc
    RTL
print "MAIN ",pc
    LDA $14	;frame counter
    AND #$7F	;check if bits %01111111 are set
    ;CMP #$FF	;if you want it slower, comment out above line and uncomment this line
    BEQ Check	;if it is, check interaction
    RTL		;if not, end code
Check:
    LDA $5B	;load screen mode
    AND #$80	;check if layer 2 interaction bit is set	
    ;AND #$40	;if you only want layer 1 interaction disabled, comment out above line and uncomment this line
    BNE DL2EL1	;if it is, proceed to disable it
    LDA #$80	;else, load %10000000				\ comment out these two lines if you
    TSB $5B	;set the bit to enable layer 2 interaction	/ only want layer 1 interaction disabled
    LDA #$40	;load %01000000                                 \ comment out these two lines if you
    TSB $5B	;set the bit to disable layer 1 interaction     / don't want layer 1 interaction disabled
    REP #$20	;to 16 bit
    LDA #$5D80	;load the colour 'blue' (0060b8 hex)
    STA $0701	;store it to the back colour
    SEP #$20	;back to 8 bit
    LDA #$0B	;load the on/off sound effect
    STA $1DF9	;play it
    RTL         ;and fin 
DL2EL1:
    LDA #$80	;load %10000000					\ comment out these two lines if you
    TRB $5B	;clear the bit to enable layer 2 interaction	/ only want layer 1 interaction disabled
    LDA #$40	;load %01000000                                 \ comment out these two lines if you
    TRB $5B	;clear the bit to enable layer 1 interaction    / don't want layer 1 interaction disabled
    REP #$20	;to 16 bit
    LDA #$0CFB	;load the colour 'red' (d83818 hex)
    STA $0701	;store it to the back colour
    SEP #$20	;back to 8 bit
    LDA #$0B	;load the on/off sound effect
    STA $1DF9	;play it
    RTL         ;and fin